import * as fs from 'fs';

import archiver from 'archiver';

import config from './config';
import prettyLog from './prettyLog';

export default () => new Promise((resolve, reject) => {
  const output = fs.createWriteStream(config.archiveFilePath);
  const archive = archiver('zip');

  output.on('close', resolve);
  output.on('error', (err) => {
    prettyLog('FAILED TO ARCHIVE', 'ERROR', err.toString());
    return reject(err);
  });

  fs.readdirSync(config.archiveDirectoryPath).forEach((file) => {
    if (!file.includes('.zip')) {
      archive.file(`${config.archiveDirectoryPath}${file}`, { name: file });
    }
  });

  archive.pipe(output);
  archive.finalize();
});
