import dotenv from 'dotenv';
import del from 'del';

import authorize from './authorize';
import archive from './archive';
import upload from './upload';

import config from './config';

const removeArchives = async () => {
  try {
    await del(config.archiveDirectoryPath.concat('*.zip'));
  } catch (e) { } // eslint-disable-line no-empty
};

const conditional = (condition, consequence) => (condition ? consequence() : null);

export default (async ({ parsed: secrets }) => {
  await removeArchives();

  const archiveOnly = process.argv.includes('--archive-only');

  try {
    const token = await conditional(!archiveOnly,
      () => authorize(secrets.LEMONPI_EMAIL, secrets.LEMONPI_PASSWORD));

    await archive();

    await conditional(!archiveOnly,
      () => upload(token));
  } catch (e) { } // eslint-disable-line no-empty
})(dotenv.config());
