const chalk = require('chalk');

module.exports = (title, status, message) => {
  const color = status === 'ERROR' ? 'red' : 'green';
  const consoleWidth = process.stdout.columns;
  const seperatorWidth = (consoleWidth - title.length - 2) / 2;

  const t = chalk[color]
    .bold(`${'='.repeat(seperatorWidth)} ${title} ${'='.repeat(seperatorWidth)}`).trim();
  const m = chalk[color](`${status}: ${message}`).trim();
  const f = chalk[color].bold('='.repeat(consoleWidth)).trim();

  // eslint-disable-next-line no-console
  return console.log(`\n\n${`${t}\n\n${m}\n\n${f}`.trim()}\n\n`);
};
