import { join } from 'path';

export const PATTERN = /((module\.exports|exports)\s*=|export default)/;

export default function replace() {
  const pattern = new RegExp(PATTERN, 'g');

  const entryFile = join(__dirname, 'src/script.js');
  return {
    name: 'assert',

    async transform(code, id) {
      if (id !== entryFile) return null;

      const matches = String(code).match(pattern);
      if (!matches || !matches.length) throw new Error(`Missing exported function in the entry file: ${entryFile}`);

      if (matches.length > 1) throw new Error(`Detected multiple exports for the entry file:${entryFile}`);

      return null;
    },
  };
}
