// eslint-disable-next-line import/no-extraneous-dependencies
import MagicString from 'magic-string';

export default function replace(replacements = []) {
  return {
    name: 'find-replace',

    renderChunk(code) {
      const magicString = new MagicString(code);

      let hasReplacements = false;

      replacements.forEach(([pattern, replacement]) => {
        const regexp = new RegExp(pattern);

        const match = regexp.exec(code);
        if (match) {
          hasReplacements = true;

          const start = match.index;
          const end = start + match[0].length;

          magicString.overwrite(start, end, replacement);
        }
      });

      if (!hasReplacements) return null;

      const result = { code: magicString.toString() };

      return result;
    },
  };
}
