// eslint-disable-next-line import/no-extraneous-dependencies
import MagicString from 'magic-string';

/**
 * Encapsulates the transpiled plugin script in an iife and wraps
 * the iife in a named function for LemonPI studio
 */
export default function iife({ banner = '' } = {}) {
  return {
    name: 'iife',

    renderChunk(code) {
      const magicString = new MagicString(code);

      // wrap all generated content in an iife
      // execute the handler after the iffe, the iife should return a function!
      // wrap and return the iffe in an named function
      magicString
        .prepend(`${banner}function init(settings) { return (function() {`)
        .append('})()(settings); }');

      const result = { code: magicString.toString() };

      return result;
    },
  };
}
